<template>
    <div
        v-if="pageReady && plan"
        class="w-full"
    >
        <div
            class="w-full bg-neutral text-white flex justify-between items-center py-3"
        >
            <div class="w-12 cursor-pointer pl-4">
                <font-awesome-icon
                    icon="fa-solid fa-arrow-left"
                    size="2x"
                    @click="$router.go(-1)"
                />
            </div>
            <div class="flex-1 text-center">
                <a
                    href="javascript:"
                    class="cursor-pointer"
                    @click="$router.push({name: 'user.home'})"
                >
                    <img
                        :src="'/img/logo.png'"
                        class="h-12 mx-auto text-center"
                    />
                </a>
            </div>
            <div class="w-12" />
        </div>
        <div
            class="mb-20 relative z-0"
        >
            <img
                :src="plan.featured_photo"
                class="aspect-video object-cover"
            />
            <div
                v-if="parseInt(investment.status) !== 1"
                class="absolute inset-y-2 right-2"
            >
                <a
                    href="javascript:"
                    class="cursor-pointer w-8 h-8"
                    @click="tryPopupAction"
                >
                    <img
                        :src="'/img/portfolio/action-icon.png'"
                        class="w-8 h-8"
                    />
                </a>
            </div>
        </div>
        <template
            v-if="plan"
        >
            <div
                class="relative mx-8 my-6 flex flex-col space-y-2 -mt-36 z-1"
            >
                <div
                    class="w-full shadow-lg rounded-xl bg-white shadow-lg shadow-gray-300 px-2 py-4"
                >
                    <div
                        class="flex justify-start space-x-2 border-b border-gray-300 pb-6 mb-6"
                    >
                        <div
                            class="flex-1"
                        >
                            <div>
                                <div class="font-black leading-tight text-lg">{{ plan.plan_name }}</div>
                                <div class="font-bold leading-tight text-xs mb-2">({{ plan.code }})</div>
                            </div>
                            <div
                                class="flex justify-between capitalize items-center"
                            >
                                <div
                                    class="flex-1 flex justify-start space-x-3 items-center"
                                >
                                    <div>
                                        {{ $t(`plan_${plan.setting.plan_type}_category`)}}
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div
                        class="flex justify-between"
                    >
                        <div
                            class="flex-1 font-black flex justify-start items-center text-xl"
                        >
                            <span
                                v-if="plan.return_percentage_from > 0"
                                class="text-green-500 text-2xl "
                            >
                                +{{ plan.return_percentage_from }}%
                            </span>
                            <span
                                v-else-if="plan.return_percentage_from < 0"
                                class="text-red-600 text-2xl font-black"
                            >
                                {{ plan.return_percentage_from }}%
                            </span>
                            <span
                                class="px-2"
                            >
                                to
                            </span>
                            <span
                                v-if="plan.return_percentage_to > 0"
                                class="text-green-500 text-2xl "
                            >
                                +{{ plan.return_percentage_to }}%
                            </span>
                            <span
                                v-else-if="plan.return_percentage_to < 0"
                                class="text-red-600 text-2xl font-black"
                            >
                                {{ plan.return_percentage_to }}%
                            </span>
                        </div>
                        <div>
                            <div
                                class="bg-red-500 text-white font-bold text-xs px-4 py-1.5"
                            >
                                {{ plan.return_cycle }}
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </template>
        <div
            class="px-3 w-full lg:max-w-[400px] lg:text-center lg:mx-auto grid grid-cols-2 gap-2 mt-4"
        >
            <div
                class="rounded-xl bg-white shadow-lg shadow-gray-300 grid-cols-1 flex flex-col px-2 py-4"
            >
                <div
                    class="flex justify-start space-x-3"
                >
                    <div>
                        <img
                            :src="'/img/portfolio/buy-in-amount.png'"
                            class="w-8"
                        />
                    </div>
                    <div
                        class="flex flex-col justify-start items-start"
                    >
                        <div
                            class="text-[10px] font-bold mb-1 leading-tight capitalize"
                        >
                            {{ $t('buy_in_amount')}}
                        </div>
                        <div
                            class="font-black"
                        >
                            {{ $helper.fundFormat(investment.total_invest) }}
                        </div>
                    </div>
                </div>
            </div>
            <div
                class="rounded-xl bg-white shadow-lg shadow-gray-300 grid-cols-1 flex flex-col px-2 py-4"
            >
                <div
                    class="flex justify-start space-x-3"
                >
                    <div>
                        <img
                            :src="'/img/portfolio/contract-period.png'"
                            class="w-8"
                        />
                    </div>
                    <div
                        class="flex flex-col justify-start items-start"
                    >
                        <div
                            class="text-[10px] font-bold mb-1 leading-tight capitalize"
                        >
                            {{ $t('contract_period')}}
                        </div>
                        <div
                            v-if="investment.lock_capital_from && investment.lock_capital_until"
                            class="font-black text-[11px]"
                        >
                            <div>
                                {{ moment(investment.lock_capital_from).format('YYYY-MM-DD HH:mm:ss') }}
                            </div>
                            <div>
                                {{ moment(investment.lock_capital_until).format('YYYY-MM-DD HH:mm:ss') }}
                            </div>
                        </div>
                        <div
                            v-else
                            class="font-black text-xs"
                        >
                            -
                        </div>
                    </div>
                </div>
            </div>
            <div
                class="rounded-xl bg-white shadow-lg shadow-gray-300 grid-cols-1 flex flex-col px-2 py-4"
            >
                <div
                    class="flex justify-start space-x-3"
                >
                    <div>
                        <img
                            :src="'/img/portfolio/money-icon.png'"
                            class="w-8"
                        />
                    </div>
                    <div
                        class="flex flex-col justify-start items-start"
                    >
                        <div
                            class="text-[10px] font-bold mb-1 leading-tight capitalize"
                        >
                            <template
                                v-if="investment.plan_type === 'structured'"
                            >
                                {{ $t('total_realized_roi') }} ($)
                            </template>
                            <template
                                v-else-if="investment.plan_type === 'assured'"
                            >
                                {{ $t('total_unrealized_roi') }} ($)
                            </template>
                        </div>
                        <div
                            class="font-black"
                        >
                            $ {{ $helper.fundFormat(investment.total_roi) }}
                        </div>
                    </div>
                </div>
            </div>
            <div
                class="rounded-xl bg-white shadow-lg shadow-gray-300 grid-cols-1 flex flex-col px-2 py-4"
            >
                <div
                    class="flex justify-start space-x-3"
                >
                    <div>
                        <img
                            :src="'/img/portfolio/money-icon.png'"
                            class="w-8"
                        />
                    </div>
                    <div
                        class="flex flex-col justify-start items-start"
                    >
                        <div
                            class="text-[10px] font-bold mb-1 leading-tight capitalize"
                        >
                            <template
                                v-if="investment.plan_type === 'structured'"
                            >
                                {{ $t('total_realized_roi') }} (%)
                            </template>
                            <template
                                v-else-if="investment.plan_type === 'assured'"
                            >
                                {{ $t('total_unrealized_roi') }} (%)
                            </template>
                        </div>
                        <div
                            class="font-black"
                        >
                            {{ $helper.fundFormat((investment.total_roi / investment.total_invest) * 100) }} %
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div
            v-if="investment.plan_type === 'structured' && parseInt(investment.status) === 2"
            class="py-6 w-full lg:max-w-[400px] lg:mx-auto"
        >
            <div
                class="px-2"
            >
                <div
                    class="cursor-pointer px-4 py-2 rounded-lg text-center w-full uppercase font-black tracking-wider"
                    :class="{
                        'bg-red-500 text-white': parseInt(investment.opt_in) === 1,
                        'bg-green-500 text-white': parseInt(investment.opt_in) === 0
                    }"
                    @click="optPopup = true"
                >
                    {{ parseInt(investment.opt_in) === 1 ? $t('opt_out') : $t('opt_in') }}
                </div>
            </div>
        </div>
        <div
            class="py-6 w-full lg:max-w-[400px] lg:mx-auto"
        >
            <div class="pl-2 font-black">
                <template
                    v-if="investment.plan_type === 'structured'"
                >
                    {{ $t('realized_return_on_investment_records') }}
                </template>
                <template
                    v-else-if="investment.plan_type === 'assured'"
                >
                    {{ $t('unrealized_return_on_investment_records') }}
                </template>
            </div>
            <div
                class="py-4 px-3 flex flex-col justify-start space-y-3"
            >
                <div
                    v-for="transaction in transactions"
                    :key="`tx-${transaction.id}`"
                    class="bg-white p-2 rounded-lg shadow shadow-gray-300"
                >
                    <div
                        class="flex justify-between space-x-2 mb-2 items-center capitalize"
                    >
                        <div>{{ $t('roi_declare_date_time') }}</div>
                        <div class="font-black">{{ moment(transaction.created_at).format('YYYY-MM-DD hh:mm') }}</div>
                    </div>
                    <template
                        v-if="parseInt(transaction.transaction_type) === 101"
                    >
                        <div
                            class="flex justify-between space-x-2 mb-2 items-center capitalize"
                        >
                            <div>{{ $t('trade_result') }}</div>
                            <div
                                class="font-black text-green-600"
                            >
                                {{ $t('profit') }}
                            </div>
                        </div>
                        <div
                            class="flex justify-between space-x-2 mb-2 items-center capitalize"
                        >
                            <div>{{ $t(transaction.plan_type === 'structured' ? 'realized_roi' : 'unrealized_roi') }}</div>
                            <div
                                class="font-black text-green-600"
                            >
                                $ {{ $helper.fundFormat(transaction.amount) }}
                            </div>
                        </div>
                    </template>
                    <template
                        v-else-if="parseInt(transaction.transaction_type) === 102"
                    >
                        <div
                            class="flex justify-between space-x-2 mb-2 items-center capitalize"
                        >
                            <div>{{ $t('trade_result') }}</div>
                            <div
                                class="font-black text-red-600"
                            >
                                {{ $t('loss') }}
                            </div>
                        </div>
                        <div
                            class="flex justify-between space-x-2 mb-2 items-center capitalize"
                        >
                            <div>{{ $t(investment.plan_type === 'structured' ? 'realized_roi' : 'unrealized_roi') }}</div>
                            <div
                                class="font-black text-red-500"
                            >
                                $ {{ $helper.fundFormat(transaction.amount) }}
                            </div>
                        </div>
                    </template>
                </div>
            </div>
        </div>
        <confirmation-prompt
            v-if="actionPopup"
            @close="onPopupActionClose"
        >
            <structured-action
                v-if="plan && plan.setting && plan.setting.plan_type === 'structured'"
                :plan="plan"
                :investment="investment"
                @close="onPopupActionClose"
            />
            <assured-action
                v-else-if="plan && plan.setting && plan.setting.plan_type === 'assured'"
                :plan="plan"
                :investment="investment"
                @close="onPopupActionClose"
            />
        </confirmation-prompt>
        <confirmation-prompt
            v-if="optPopup"
            @close="optPopup = false"
        >
            <opt-action
                :plan="plan"
                :investment="investment"
                @close="onOptClose"
            />
        </confirmation-prompt>
    </div>
</template>

<script setup>
import {ref, computed, onMounted} from "vue";
import axios from "axios";
import {useRoute, useRouter} from "vue-router";
import {useSettingStore} from "~/stores/setting.js";
import ConfirmationPrompt from "~/components/confirmation-prompt.vue";
import StructuredAction from "~/pages/main/portfolio/fund/structured-action.vue";
import AssuredAction from "~/pages/main/portfolio/fund/assured-action.vue";
import moment from "moment";
import OptAction from "~/pages/main/portfolio/fund/opt-action.vue";

const $settingStore = useSettingStore();
const $route = useRoute();
const $router = useRouter();
const pageReady = ref(false);
const investment = ref({});
const actionPopup = ref(false);
const optPopup = ref(false);
const transactions = ref([]);

const plan = computed(() => {
    if (!investment.value) return null;
    return $settingStore.settings.plans.find(r => {
        return parseInt(r.id) === parseInt(investment.value.investment_plan_id);
    });
});

const loadData = async () => {
    const data = await axios.post(`/portfolio/contract/${$route.params.contract_id}`);

    if (data.model) {
        investment.value = data.model;
    } else {
        await $router.go(-1);
    }

    if (data.transactions) {
        transactions.value = {...data.transactions};
    }
};

onMounted(async () => {
    try {
        await $settingStore.fetchSettings();

        await loadData();

        pageReady.value = true;
    } catch (e) {
        console.log(e);
    }
});

const tryPopupAction = () => {
    if (plan.value && parseInt(plan.value.status) !== 1) {
        actionPopup.value = true;
    }
};

const onPopupActionClose = async (redirect = false) => {
    if (redirect === true) {
        await $router.replace({name: 'user.portfolio.fund.home', params: {code: plan.value.code}});
    } else {
        actionPopup.value = null;
        await loadData();
    }
}

const onOptClose = async () => {
    optPopup.value = false;
    await loadData();
}
</script>
